import java.util.ArrayList;
import java.util.List;

import de.verit.klaros.core.model.KlarosTestCase;
import de.verit.klaros.core.model.KlarosTestCaseResult;
import de.verit.klaros.core.model.KlarosTestSuite;
import de.verit.klaros.scripting.KlarosContext;
import de.verit.klaros.scripting.KlarosScript;

public class TestrunReportPerSuite implements KlarosScript {

	public void execute(KlarosContext context) {
	    // Get the parameter name containing the name of the test suite
	    String suiteName = (String)context.getParameterValue("suiteName");
	    KlarosTestSuite testSuite;
	    // Execute the query using the parameter
	    String suiteQuery = "select g from KlarosTestSuite g where g.name='" + suiteName + "'";
            if (context.getActiveProject() != null) {
              suiteQuery += " and g.configuration.name='";
              suiteQuery += context.getActiveProject().getName();
              suiteQuery += "'";
            }
	    List<KlarosTestSuite> testSuites = (List<KlarosTestSuite>) context.executeQuery(suiteQuery);
	    // Add the first result to the render context - only one result is expected
	    if (!testSuites.isEmpty()) {
	    	testSuite = (KlarosTestSuite) testSuites.get(0);
	        context.add("testSuite", testSuite);
			List<KlarosTestCaseResult> error = new ArrayList<KlarosTestCaseResult>();
			List<KlarosTestCaseResult> failure = new ArrayList<KlarosTestCaseResult>();
			List<KlarosTestCaseResult> success = new ArrayList<KlarosTestCaseResult>();
			List<KlarosTestCaseResult> skipped = new ArrayList<KlarosTestCaseResult>();
		    // prepare data for the pie chart
		    // iterate over the test cases of the specified suite
			for (KlarosTestCase klarosTestCase : testSuite.getTestCases()) {
				// iterate over the test results of every test case
				for (KlarosTestCaseResult testResult: klarosTestCase.getResults()) {
					if (testResult.isError()) error.add(testResult);
					else if (testResult.isFailure()) failure.add(testResult);
					else if (testResult.isPassed()) success.add(testResult);
					else if (testResult.isSkipped()) skipped.add(testResult);
				}
			}
			context.add("error", error);
			context.add("failure", failure);
			context.add("success", success);
			context.add("skipped", skipped);
	    }
	}
}
